<template>
  <div class="container">
    <!-- 查询配置 -->
    <div style="padding: 0px 20px">
      <div ref="lxHeader">
        <LxHeader icon="md-apps" text="模块管理" style="margin-bottom: 10px; border: 0px; margin-top: 15px">
          <div slot="content"></div>
          <slot>
            <div>
              <Button type="primary" @click="edit()">新增模块</Button>
            </div>
          </slot>
        </LxHeader>
      </div>
      <div class="table-tree">
        <el-table :data="tableData" :height="tableHeight" class="v-table" style="width: 100%;margin-bottom: 20px;"
          row-key="id" border :tree-props="{children: 'children', hasChildren: 'hasChildren'}">
          <el-table-column type="index" align="center">
          </el-table-column>
          <el-table-column prop="name" label="模块名称" width="180">
          </el-table-column>
          <el-table-column prop="remark" label="备注">
          </el-table-column>
          <el-table-column prop="sort" align="center" label="排序" width="80">
          </el-table-column>
          <el-table-column fixed="right" label="操作" width="300">
            <template slot-scope="scope">
              <Button type="primary" @click="addchildren(scope.row)" size="small" style="margin-left: 10px;"
                ghost>下级目录</Button>
              <Button type="error" @click="del(scope.row)" size="small" style="margin-left: 10px;" ghost>删除</Button>
              <Button type="primary" @click="edit(scope.row)" size="small" style="margin-left: 10px;" ghost>编辑</Button>
            </template>
          </el-table-column>
        </el-table>
      </div>
    </div>

    <el-dialog title="目录编辑" :visible.sync="dialogFormVisible" width="30%">
      <el-form :model="form" :rules="rules" ref="form" label-position="right" :label-width="formLabelWidth">
        <el-form-item label="上级目录">
          <el-input v-model="form.pname" disabled autocomplete="off"></el-input>
        </el-form-item>
        <el-form-item label="目录名称" prop="name">
          <el-input v-model="form.name" autocomplete="off"></el-input>
        </el-form-item>
        <el-form-item label="备注" prop="remark">
          <el-input type="textarea" placeholder="请输入备注内容" v-model="form.remark" maxlength="300" show-word-limit>
          </el-input>
        </el-form-item>

        <el-form-item label="排序" prop="sort">
          <el-input v-model="form.sort" autocomplete="off"></el-input>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button @click="resetForm('form')">取 消</el-button>
        <el-button type="primary" v-preventReClick @click="submitForm('form')">确 定</el-button>
      </div>
    </el-dialog>

  </div>
</template>
<script>
  import LxHeader from "@/components/LxHeader/index.vue";
  import {
    listregulation,
    save,
    store,
    del,
    get
  } from "@/api/lawsfile/regulation.js";

  export default {
    components: {
      LxHeader
    },
    created() {
      this.initLoad();
      this.load();

    },
    mounted() {},
    data() {
      return {
        dialogFormVisible: false,
        formLabelWidth: "120px",
        form: {
          name: "",
          id: "",
          pid: "0",
          pname: "根目录",
          type: 1,
          sort:0
        },
        rules: {
          name: [{
            required: true,
            message: '请输入目录名称',
            trigger: 'blur'
          }]
        },
        tableHeight: 0,
        //查询条件字段
        searchFields: {
          KeyWord: ""
        },
        tableData: []
      }
    },
    methods: {
      initLoad() {
        var that = this;
        var clientHeight = document.documentElement.clientHeight
        var lxHeader_height = 96.5; //查询 头部
        var paginationHeight = 37; //分页的高度
        var topHeight = 50; //页面 头部
        let tableHeight = clientHeight - lxHeader_height - topHeight - paginationHeight - 20;
        that.tableHeight = tableHeight;
      },
      load() {
        // let type = parseInt(this.$route.path.split("_")[1]);
        // let type  =  '2,1,3,12'
        var that = this;
        let type = parseInt(this.$route.path.split("_")[1]);
        let type1 = parseInt(this.$route.path.split("_")[2]);
        // if(type1){
        //   type = type1
        // }else{
        //   // if(type==10){
        //   //   type = 10
        //   // }else{
        //     type  =  '2,1,3,12'
        //   // }
        // }

        listregulation(1, type).then(response => {
          that.tableData = response;
        }).catch(error => {
          //reject(error)
        })

      },
      edit(obj) {
        this.form = this.$options.data().form;
        this.form.type = parseInt(this.$route.path.split("_")[1]);
        if (obj) {
          var result = Object.assign(this.form, obj);
          result.pname = obj.p_menu ? obj.p_menu.name : "根目录";
          result.regulation_menu_id = obj.id;
          this.form = result;
        }
        this.dialogFormVisible = true;
      },
      addchildren(obj) {
        this.form = this.$options.data().form;
        this.form.type = parseInt(this.$route.path.split("_")[1]);
        if (obj) {
          this.form.type = obj.type
          this.form.pname = obj.name;
          this.form.pid = obj.id;
          this.dialogFormVisible = true;
        }
      },
      submitForm(formName) {
        var that = this;
        this.$refs[formName].validate((valid) => {
          if (valid) {
            if (that.form.id) {
              save(that.form).then(response => {
                console.log(response)
                this.$Message.success('操作成功');
                that.dialogFormVisible = false;
                that.load();
              }).catch(error => {
                reject(error)
              })
            } else {
              store(that.form).then(response => {
                console.log(response)
                this.$Message.success('操作成功');
                that.dialogFormVisible = false;
                that.load();
              }).catch(error => {
                reject(error)
              })
            }

          } else {
            this.$Message.error('数据校验失败');
            return false;
          }
        });
      },
      resetForm(formName) {
        var that = this;
        this.$refs[formName].resetFields();
        that.dialogFormVisible = false;
      },
      del(obj) {
        var that = this;
        if (obj) {
          this.$Modal.confirm({
            title: '确认要删除数据？',
            onOk: () => {
              del(obj.id).then(response => {
                this.$Message.success('操作成功');
                that.load();
              }).catch(error => {
                console.log(error)
                reject(error)
              })
            },
            onCancel: () => {
              //this.$Message.info('Clicked cancel');
            }
          });
        }
      },
    }
  };
</script>
